local GearEvaluator = _G.GearEvaluator
local GearEvaluator_Searcher = GearEvaluator:NewModule("Searcher", "AceTimer-3.0", "AceEvent-3.0")

function GearEvaluator_Searcher:OnInitialize()
  local defaults = {
    profile = {
      interval = 0.5,
      burst = 100
    }
  }
  
  self.db = GearEvaluator.db:RegisterNamespace("Searcher", defaults)
end

function GearEvaluator_Searcher:OnEnable()
  self:RegisterEvent("PLAYER_REGEN_ENABLED", "HandleRegenEvent")
  self:RegisterEvent("PLAYER_REGEN_DISABLED", "HandleRegenEvent")
end

function GearEvaluator_Searcher:OnDisable()
  self:UnregisterEvent("PLAYER_REGEN_ENABLED")
  self:UnregisterEvent("PLAYER_REGEN_DISABLED")
end

function GearEvaluator_Searcher:HandleRegenEvent(event)
  if (event == "PLAYER_REGEN_ENABLED") then
    self.searchTimer = self:ScheduleRepeatingTimer("DoSearchBurst", self.db.profile.interval)
  else
    self:CancelTimer(self.searchTimer, true)
  end
end

function GearEvaluator_Searcher:DoSearchBurst()
  GearEvaluator:Debug(5, "Searching for better gear...")
end
